--local addon = LibStub("AceAddon-3.0"):GetAddon("Broker_MountQ");
local MountQData = {};

local FLYING_TEXT = "Flying"
local GROUND_TEXT = "Ground"
local AQUATIC_TEXT = "Aquatic"

local FLYING, GROUND, AQUATIC = 1, 2, 3

-- Mount Categories
local HORSE_TEXT = "Horses"
local WOLF_TEXT = "Wolves"
local FELINE_TEXT = "Felines"
local BEAR_TEXT = "Bears"
local RAM_TEXT = "Rams"
local TALBUK_TEXT = "Talbuks"
local KODO_TEXT = "Kodos"
local ELEPHANT_TEXT = "Elephants"
local RAPTOR_TEXT = "Raptors"
local MECHANICAL_TEXT = "Mechanical"
local CRAFTED_TEXT = "Crafted"
local WINDRIDER_TEXT = "Windriders"
local INSECT_TEXT = "Insects"
local BIRD_TEXT = "Birds"
local DRAKE_TEXT = "Drakes"
local NETHERRAY_TEXT = "Nether Rays"
local GRYPHON_TEXT = "Gryphons"
local PVP_TEXT = "PvP Mounts"
local CAMEL_TEXT = "Camels"
local SEASONAL_TEXT = "Seasonal"
local SPECIAL_TEXT = "Specials"
local UNKNOWN_TEXT = "Unknown"

local GENERAL_TEXT = "General"
local ALL_TEXT = "All"

local CNT = 4;
local HORSE, WOLF, FELINE, BEAR, RAM, TALBUK, KODO, ELEPHANT, RAPTOR, MECHANICAL, CRAFTED, WINDRIDER, INSECT, DRAKE, NETHERRAY, SEASONAL, SPECIAL, BIRD, GRYPHON, PVP, CAMEL, UNKNOWN, GENERAL, ALL = CNT, CNT+1, CNT+2, CNT+3, CNT+4, CNT+5, CNT+6, CNT+7, CNT+8, CNT+9, CNT+10, CNT+11, CNT+12, CNT+13, CNT+14, CNT+15, CNT+16, CNT+17, CNT+18, CNT+19, CNT+20, CNT+21, CNT+22, CNT+23
CNT = CNT + 24;

-- Generic global types
MountQGeneralType = GENERAL_TEXT
MountQAllType = ALL_TEXT

-- Mount SubCategories
-- Horses
CNT = CNT + 0;

-- Wolves
CNT = CNT+0

-- Felines
CNT = CNT+0

-- Bears
CNT = CNT+0

-- Rams
CNT = CNT+0

--Talbuks
CNT = CNT+0

--Kodos
CNT = CNT+0

--Elephants
local MAMMOTH_TEXT = "Mammoth"
local ELEKK_TEXT = "Elekks"
local MAMMOTH, ELEKK = CNT, CNT+1
CNT = CNT+2

--Raptors
CNT = CNT+0

--BIRDS
local HAWKSTRIDER_TEXT = "Hawkstriders"
local HIPPOGRYPH_TEXT = "Hyppogryphs"
local HAWKSTRIDER, HIPPOGRYPH = CNT, CNT+1
CNT = CNT+2

--Mechanical
local MECHANOSTRIDER_TEXT = "Mechanostriders"
local MECHANOSTRIDER = CNT
CNT = CNT+1

--Crafted
CNT = CNT+0

--Windriders
CNT = CNT+0

--Insects
CNT = CNT+0

--Gryphons
CNT = CNT+0

--Drakes
local NETHERWING_TEXT = "Netherwings"
local PROTO_TEXT = "Proto Drakes"
local STONEDRAKE_TEXT = "Stone Drakes"
local NETHERWING, PROTO, STONEDRAKE = CNT, CNT+1, CNT+2
CNT = CNT+3

--Nether Rays
CNT = CNT+0

--Seasonal
CNT = CNT+0

--Specials
CNT = CNT+0

-- Specials
local TCG_TEXT = "Trading Game Cards"
local TCG = CNT
CNT = CNT+1


-- Commented out variables are not needed at this time
local function AddCat(cat, text)
	-- Convert Category ID to text
	MountQData["Cat"][cat] = text;

	-- Convert Category Text to ID
--	MountQData["CatText"][text] = cat;
	
	-- Subcategories in a Category
--	MountQData["CatSubCat"][cat] = { GENERAL, ALL }
end

local function AddSubCat(subcat, text, cat)
	-- Convert SubCategory ID to text
	MountQData["SubCat"][subcat] = text;

	-- Convert SubCategory Text to ID
--	MountQData["SubCatText"][text] = subcat;

	-- Convert Subcateogry to Category
	MountQData["SubCatCat"][subcat] = cat;
--	table.insert(MountQData["CatSubCat"][cat], 1, subcat);
end

local function MountQData_InitializeCategories()
	MountQData["Cat"] = {};
--	MountQData["CatText"] = {};
--	MountQData["CatSubCat"] = {};
	AddCat(AQUATIC, AQUATIC_TEXT);
	AddCat(HORSE, HORSE_TEXT);
	AddCat(WOLF, WOLF_TEXT);
	AddCat(FELINE, FELINE_TEXT);
	AddCat(BEAR, BEAR_TEXT);
	AddCat(RAM, RAM_TEXT);
	AddCat(TALBUK, TALBUK_TEXT);
	AddCat(KODO, KODO_TEXT);
	AddCat(ELEPHANT, ELEPHANT_TEXT);
	AddCat(RAPTOR, RAPTOR_TEXT);
	AddCat(MECHANICAL, MECHANICAL_TEXT);
	AddCat(CRAFTED, CRAFTED_TEXT);
	AddCat(WINDRIDER, WINDRIDER_TEXT);
	AddCat(INSECT, INSECT_TEXT);
	AddCat(BIRD, BIRD_TEXT);
	AddCat(DRAKE, DRAKE_TEXT);
	AddCat(NETHERRAY, NETHERRAY_TEXT);
	AddCat(GRYPHON, GRYPHON_TEXT);
	AddCat(PVP, PVP_TEXT);
	AddCat(CAMEL, CAMEL_TEXT);
	AddCat(SEASONAL, SEASONAL_TEXT);
	AddCat(SPECIAL, SPECIAL_TEXT);
	AddCat(GENERAL, GENERAL_TEXT);
	AddCat(ALL, ALL_TEXT);
end

local function MountQData_InitializeSubCategories1()
	MountQData["SubCat"] = {};
--	MountQData["SubCatText"] = {};
	MountQData["SubCatCat"] = {};
	AddSubCat(MAMMOTH, MAMMOTH_TEXT, ELEPHANT);
	AddSubCat(ELEKK, ELEKK_TEXT, ELEPHANT);
	AddSubCat(HAWKSTRIDER, HAWKSTRIDER_TEXT, BIRD);
	AddSubCat(HIPPOGRYPH, HIPPOGRYPH_TEXT, BIRD);
	AddSubCat(MECHANOSTRIDER, MECHANOSTRIDER_TEXT, MECHANICAL);
	AddSubCat(NETHERWING, NETHERWING_TEXT, DRAKE);
	AddSubCat(PROTO, PROTO_TEXT, DRAKE);
	AddSubCat(STONEDRAKE, STONEDRAKE_TEXT, DRAKE);
	AddSubCat(TCG, TCG_TEXT, SPECIAL);
end

function MountQData_Initialize()
	MountQData_InitializeCategories();
	MountQData_InitializeSubCategories1();

	MountQData["Name"] = {};
end

function MountQData_IsKnown(name)
	if MountQData["Name"][name] ~= nil then return 1 else return nil end;
end

function MountQData_AddKnownMount(spellid, name, icon)
	MountQData["Name"][name] = { spellid, icon };
end

local function MountQData_GetCategory(id)
	local text = MountQData["Cat"][id];
	
	if text == nil then
		cat = MountQData["SubCatCat"][id];
		return MountQData["Cat"][cat];
	end
	return text;
end

function MountQData_GetSpellID(pet)
	return MountQData["Name"][pet][1];
end

function MountQData_GetIcon(pet)
	return MountQData["Name"][pet][2];
end

local function MountQData_PetCategories(spellid)
	local petinfo = MountQData["MountTypes"][spellid];
	if petinfo == nil then
		return nil;
	end
	return MountQData["MountTypes"][spellid][2];
end

function MountQData_IsMountInCat(name, category)
	if category == ALL then return true end;

	local spellid = MountQData["Name"][name][1];
	local types = MountQData_PetCategories(spellid);

	if types == nil then return false end;

	for i, j in pairs(types) do
		local cat = MountQData_GetCategory(j);
		if cat == category then return true end
	end
	return false;
end

function MountQData_GetCatList(spellid) 
	local CatList = {};
	table.insert(CatList, 1, {ALL_TEXT, GENERAL_TEXT});

	local types = MountQData_PetCategories(spellid); 

	if types == nil then
		table.insert(CatList, 1, {UNKNOWN_TEXT, GENERAL_TEXT});
		return CatList;
	end

	for i, j in pairs(types) do
		local cat = MountQData_GetCategory(j);
		local subcat = MountQData["SubCat"][j];

		if subcat == nil then
			subcat = GENERAL_TEXT;
		end
		table.insert(CatList, 1, {cat, subcat})
	end
	return CatList;
end

function MountQData_IsGround(name)
	local spellid = MountQData["Name"][name][1];
	local pet = MountQData["MountTypes"][spellid];
	-- Do some logic to read the tooltip and guess
	if pet == nil then return true end
	if tContains(pet[1], GROUND) == nil then
		return false;
	else
		return true;
	end
end

function MountQData_IsFlier(name)
	local spellid = MountQData["Name"][name][1];
	local pet = MountQData["MountTypes"][spellid];
	-- Do some logic to read the tooltip and guess
	if pet == nil then return false end
	if tContains(pet[1], FLYING) == nil then
		return false;
	else
		return true;
	end
end

function MountQData_IsForm(spell)
	if spell == nil then return false end;
	local check = MountQData_GetSpellID(spell);
	if check == 40120 or check == 33943 or check == 87840 or check == 1066 then
		return true;
	end
	return false;
end

MountQData["MountTypes"] = {
	[40120]={ { FLYING }, { BIRD } },	-- Swift Flight Form
	[33943]={ { FLYING }, { BIRD } }, 	-- Flight Form
	[87840]={ { GROUND }, { WOLF } }, 	-- Running Wild (Worgen)
	[1066]={ { AQUATIC }, { AQUATIC } },	-- Aquatic Form

	[75207]={ { AQUATIC }, { AQUATIC } },   -- Abyssal Seahorse
	[60025]={ { FLYING }, { DRAKE } },	-- Albino Drake
	[98204]={ { GROUND }, { BEAR } },	-- Amani Battle Bear
	[43688]={ { GROUND }, { BEAR } },	-- Amani War Bear
	[63844]={ { FLYING }, { HYPOGRYPH } },	-- Argent Hippogryph
	[67466]={ { GROUND }, { HORSE } },	-- Argent Warhorse
	[96491]={ { GROUND }, { RAPTOR} }, 	-- Armored Razzashi Raptor
	[40192]={ { FLYING }, { SPECIAL } },	-- Ashes of Al'ar
	[41514]={ { FLYING }, { NETHERWING } },	-- Azure Netherwing Drake
	[59567]={ { FLYING }, { DRAKE } },	-- Azure Drake
	[51412]={ { GROUND }, { BEAR } },	-- Big Battle Bear
	[58983]={ { GROUND }, { BEAR } },	-- Big Blizzard Bear
	[71342]={ { FLYING }, { MECHANICAL, SEASONAL } },	-- Big Love Rocket
	[59650]={ { FLYING }, { DRAKE } },	-- Black Drake
	[59976]={ { GROUND }, { PROTO } },	-- Black Proto-Drake
	[26656]={ { GROUND }, { INSECT } },	-- Black Qiraji Battle Tank
	[72808]={ { FLYING }, { PROTO } },	-- Bloodbathed Frostbrood Vanquisher
	[59568]={ { FLYING }, { DRAKE } },	-- Blue Drake
	[59996]={ { FLYING }, { PROTO } },	-- Blue Proto-Drake
	[25953]={ { GROUND }, { INSECT } },	-- Blue Qiraji Battle Tank
	[39803]={ { FLYING }, { NETHERRAY } },	-- Blue Riding Nether Ray
	[43899]={ { GROUND }, { RAM, SEASONAL } },	-- Brewfest Ram
	[59569]={ { FLYING }, { DRAKE } },	-- Bronze Drake
	[88748]={ { GROUND }, { CAMEL } },	-- Brown Riding Camel
	[75614]={ { FLYING, GROUND }, { HORSE } },	-- Celestial Steed
	[43927]={ { FLYING }, { HYPOGRYPH } },	-- Cenarion War Hippogryph
	[41515]={ { FLYING }, { NETHERWING } },	-- Cobalt Netherwing Drake
	[39315]={ { GROUND }, { TALBUK } },	-- Cobalt Riding Talbuk
	[34896]={ { GROUND }, { TALBUK } },	-- Cobalt War Talbuk
	[73313]={ { GROUND }, { HORSE } },	-- Crimson Deathcharger
	[88990]={ { FLYING }, { BIRD } },	-- Dark Phoenix
	[39316]={ { GROUND }, { TALBUK, PVP } },	-- Dark Riding Talbuk
	[34790]={ { GROUND }, { TALBUK, PVP } },	-- Dark War Talbuk
	[64927]={ { FLYING }, { PROTO, PVP } },	-- Deadly Gladiator's Frostwyrm
	[88335]={ { FLYING }, { STONEDRAKE } }, -- Drake of the East Wind
	[88742]={ { FLYING }, { STONEDRAKE } }, -- Drake of the North Wind
	[88744]={ { FLYING }, { STONEDRAKE } }, -- Drake of the South Wind
	[88741]={ { FLYING }, { PVP, STONEDRAKE } }, -- Drake of the West Wind
	[84751]={ { GROUND }, { RAPTOR } },	-- Fossilized Raptor
	[36702]={ { GROUND }, { HORSE } },	-- Fiery Warhorse
	[49379]={ { GROUND }, { KODO, SEASONAL } },	-- Great Brewfest Kodo
	[61294]={ { FLYING }, { PROTO } },	-- Green Proto-Drake
	[26056]={ { GROUND }, { INSECT } },	-- Green Qiraji Battle Tank
	[39798]={ { FLYING }, { NETHERRAY } },	-- Green Riding Nether Ray
	[88750]={ { GROUND }, { CAMEL } }, 	-- Grey Riding Camel
	[48025]={ { FLYING, GROUND }, { HORSE, SEASONAL } },	-- Headless Horseman's Mount
	[72807]={ { FLYING }, { PROTO } },	-- Icebound Frostbrood Vanquisher
	[72286]={ { FLYING }, { HORSE } },	-- Invincible
	[63956]={ { FLYING }, { PROTO } },	-- Ironbound Proto-Drake
	[65917]={ { GROUND }, { TCG } },	-- Magic Rooster
	[44744]={ { FLYING }, { DRAKE, PVP } },	-- Merciless Nether Drake
	[63796]={ { FLYING }, { MECHANICAL } },	-- Mimiron's Head
	[93623]={ { FLYING }, { DRAKE, TCG } },	-- Mottled Drake
	[69395]={ { FLYING }, { DRAKE } },	-- Onyxian Drake
	[41513]={ { FLYING }, { NETHERWING } },	-- Onyx Netherwing Drake
	[88718]={ { FLYING }, { STONEDRAKE } },	-- Phosphorescent Stone Drake
	[60021]={ { FLYING }, { PROTO } },	-- Plagued Proto-Drake
	[41516]={ { FLYING }, { NETHERWING } },	-- Purple Netherwing Drake
	[39801]={ { FLYING }, { NETHERRAY } },	-- Purple Riding Nether Ray
	[41252]={ { GROUND }, { BIRD } },	-- Raven Lord
	[59570]={ { FLYING }, { DRAKE } },	-- Red Drake
	[59961]={ { FLYING }, { PROTO } },	-- Red Proto-Drake
	[26054]={ { GROUND }, { INSECT } },	-- Red Qiraji Battle Tank
	[39800]={ { FLYING }, { NETHERRAY } },	-- Red Riding Nether Ray
	[30174]={ { GROUND }, { TCG } },	-- Riding Turtle
	[17481]={ { GROUND }, { HORSE } },	-- Rivendare's Deathcharger
	[63963]={ { FLYING }, { PROTO } },	-- Rusted Proto-Drake
	[93326]={ { FLYING }, { STONEDRAKE } },	-- Sandstone Drake
	[64731]={ { GROUND, AQUATIC }, { AQUATIC } },	-- Sea Turtle
	[39802]={ { FLYING }, { NETHERRAY } },	-- Silver Riding Nether Ray
	[39317]={ { GROUND }, { TALBUK } },	-- Silver Riding Talbuk
	[34898]={ { GROUND }, { TALBUK } },	-- Silver War Talbuk
	[42776]={ { GROUND }, { TALBUK } },	-- Spectral Tiger
	[98718]={ {  GROUND, AQUATIC }, { AQUATIC } },	-- Subdued Seahorse
	[69820]={ { GROUND }, { KODO } }, 	-- Sunwalker Kodo
	[43900]={ { GROUND }, { RAM, SEASONAL } },	-- Swift Brewfest Ram
	[37015]={ { FLYING }, { DRAKE, PVP } },	-- Swift Nether Drake
	[24242]={ { GROUND }, { RAPTOR } },	-- Swift Razzashi Raptor
	[42777]={ { GROUND }, { FELINE } },	-- Swift Spectral Tiger
	[46628]={ { GROUND }, { HAWKSTRIDER } },	-- Swift White Hawkstrider
	[49322]={ { GROUND }, { SPECIAL } },	-- Swift Zhevra
	[96499]={ { GROUND }, { FELINE } }, 	-- Swift Zulian Panther
	[24252]={ { GROUND }, { FELINE } },	-- Swift Zulian Tiger
	[88749]={ { GROUND }, { CAMEL } },	-- Tan Riding Camel
	[39318]={ { GROUND }, { TALBUK } },	-- Tan Riding Talbuk
	[34899]={ { GROUND }, { TALBUK } },	-- Tan War Talbuk
	[60002]={ { FLYING }, { PROTO } },	-- Time-Lost Proto-Drake
	[59571]={ { FLYING }, { DRAKE } },	-- Twilight Drake
	[92155]={ { GROUND }, { INSECT } }, 	-- Ultramarine Qiraji Battle Tank
	[49193]={ { FLYING }, { DRAKE } },	-- Vengeful Nether Drake
	[41517]={ { FLYING }, { NETHERWING } },	-- Veridian Netherwing Drake
	[88746]={ { FLYING }, { STONEDRAKE } },	-- Vitreous Stone Drake
	[41518]={ { FLYING }, { NETHERWING } },	-- Violet Netherwing Drake
	[60024]={ { FLYING }, { PROTO } },	-- Violet Proto-Drake
	[88331]={ { FLYING }, { STONEDRAKE } },	-- Volcanic Stone Drake
	[54753]={ { GROUND }, { BEAR } },	-- White Polar Bear Mount
	[39319]={ { GROUND }, { TALBUK } },	-- White Riding Talbuk
	[34897]={ { GROUND }, { TALBUK } },	-- White War Talbuk
	[98727]={ { FLYING, GROUND }, { FELINE } },	-- Winged Guardian
	[74918]={ { GROUND }, { TCG } }, 	-- Wooly White Rhino
	[46197]={ { FLYING }, { MECHANICAL, TCG } },	-- X-51 Nether-Rocket
	[46199]={ { FLYING }, { MECHANICAL, TCG } },	-- X-51 Nether-Rocket X-TREME
	[75973]={ { FLYING }, { MECHANICAL, SPECIAL } },	-- X-53 Touring Rocket
	[26055]={ { GROUND }, { INSECT } },	-- Yellow Qiraji Battle Tank

-- alliance mounts
	[60114]={ { GROUND }, { BEAR } },	-- Armored Brown Bear
	[61229]={ { FLYING }, { GRYPHON } },	-- Armored Snowy Gryphon
	[22719]={ { GROUND }, { MECHANOSTRIDER, PVP } },	-- Black Battlestrider
	[470]={ { GROUND }, { HORSE } },	-- Black Stallion Bridle
	[60118]={ { GROUND }, { BEAR } },	-- Black War Bear
	[48027]={ { GROUND }, { ELEKK, PVP } },	-- Black War Elekk
	[59785]={ { GROUND }, { MAMMOTH, PVP} },	-- Black War Mammoth
	[22720]={ { GROUND }, { RAM, PVP } },	-- Black War Ram
	[22717]={ { GROUND }, { HORSE, PVP } },	-- Black War Steed
	[22723]={ { GROUND }, { FELINE, PVP } },	-- Black War Tiger
	[61996]={ { FLYING }, { SPECIAL } },	-- Blue Dragonhawk
	[10969]={ { GROUND }, { MECHANOSTRIDER } },	-- Blue Mechanostrider
	[34406]={ { GROUND }, { ELEKK } },	-- Brown Elekk
	[458]={ { GROUND }, { HORSE } },	-- Brown Horse
	[6899]={ { GROUND }, { RAM } },	-- Brown Ram
	[6648]={ { GROUND }, { HORSE } },	-- Chestnut Mare
	[63637]={ { GROUND }, { FELINE } },	-- Darnassian Nightsaber
	[32239]={ { FLYING }, { GRYPHON } },	-- Ebon Gryphon
	[63639]={ { GROUND }, { ELEKK } },	-- Exodar Elekk
	[63638]={ { GROUND }, { MECHANOSTRIDER } },	-- Gnomeregan Mechanostrider
	[32235]={ { FLYING }, { GRYPHON } },	-- Golden Gryphon
	[90621]={ { GROUND }, { FELINE } },	-- Golden King
	[61465]={ { GROUND }, { MAMMOTH, PVP } },	-- Grand Black War Mammoth
	[61470]={ { GROUND }, { MAMMOTH } },	-- Grand Ice Mammoth
	[35710]={ { GROUND }, { ELEKK } },	-- Gray Elekk
	[6777]={ { GROUND }, { RAM } },	-- Gray Ram
	[35713]={ { GROUND }, { ELEKK } },	-- Great Blue Elekk
	[35712]={ { GROUND }, { ELEKK } },	-- Great Green Elekk
	[35714]={ { GROUND }, { ELEKK } },	-- Great Purple Elekk
	[65637]={ { GROUND }, { ELEKK } },	-- Great Red Elekk
	[17453]={ { GROUND }, { MECHANOSTRIDER } },	-- Green Mechanostrider
	[59799]={ { GROUND }, { MAMMOTH } },	-- Ice Mammoth
	[63636]={ { GROUND }, { RAM } },	-- Ironforge Ram
	[60424]={ { FLYING }, { MECHANICAL, CRAFTED } },	-- Mekgineer's Chopper
	[472]={ { GROUND }, { HORSE } },	-- Pinto
	[35711]={ { GROUND }, { ELEKK } },	-- Purple Elekk
	[66090]={ { GROUND }, { HORSE } },	-- Quel'dorei Steed
	[10873]={ { GROUND }, { MECHANOSTRIDER } },	-- Red Mechanostrider
	[66087]={ { FLYING }, { HYPOGRYPH } },	-- Silver Covenant Hippogryph
	[32240]={ { FLYING }, { GRYPHON } },	-- Snowy Gryphon
	[92231]={ { GROUND }, { HORSE, PVP } },	-- Spectral Steed
	[10789]={ { GROUND }, { FELINE } },	-- Spotted Frostsaber
	[23510]={ { GROUND }, { RAM, PVP } },	-- Stormpike Battle Charger
	[63232]={ { GROUND }, { HORSE } },	-- Stormwind Steed
	[66847]={ { GROUND }, { FELINE } },	-- Striped Dawnsaber
	[8394]={ { GROUND }, { FELINE } },	-- Striped Frostsaber
	[10793]={ { GROUND }, { FELINE } },	-- Striped Nightsaber
	[68057]={ { GROUND }, { HORSE } },	-- Swift Alliance Steed
	[32242]={ { FLYING }, { GRYPHON } },	-- Swift Blue Gryphon
	[23238]={ { GROUND }, { RAM } },	-- Swift Brown Ram
	[23229]={ { GROUND }, { HORSE } },	-- Swift Brown Steed
	[23221]={ { GROUND }, { FELINE } },	-- Swift Frostsaber
	[23239]={ { GROUND }, { RAM } },	-- Swift Gray Ram
	[65640]={ { GROUND }, { HORSE } },	-- Swift Gray Steed
	[32290]={ { FLYING }, { GRYPHON } },	-- Swift Green Gryphon
	[23225]={ { GROUND }, { MECHANOSTRIDER } },	-- Swift Green Mechanostrider
	[23219]={ { GROUND }, { FELINE } },	-- Swift Mistsaber
	[65638]={ { GROUND }, { FELINE } },	-- Swift Moonsaber
	[23227]={ { GROUND }, { HORSE } },	-- Swift Palomino
	[32292]={ { FLYING }, { GRYPHON } },	-- Swift Purple Gryphon
	[32289]={ { FLYING }, { GRYPHON } },	-- Swift Red Gryphon
	[23338]={ { GROUND }, { FELINE } },	-- Swift Stormsaber
	[65643]={ { GROUND }, { RAM } },	-- Swift Violet Ram
	[23223]={ { GROUND }, { MECHANOSTRIDER } },	-- Swift White Mechanostrider
	[23240]={ { GROUND }, { RAM } },	-- Swift White Ram
	[23228]={ { GROUND }, { HORSE } },	-- Swift White Steed
	[23222]={ { GROUND }, { MECHANOSTRIDER } },	-- Swift Yellow Mechanostrider
	[61425]={ { GROUND }, { MAMMOTH } },	-- Traveler's Tundra Mammoth
	[65642]={ { GROUND }, { MECHANOSTRIDER } },	-- Turbostrider
	[17454]={ { GROUND }, { MECHANOSTRIDER } },	-- Unpainted Mechanostrider
	[6898]={ { GROUND }, { RAM } },	-- White Ram
	[17229]={ { GROUND }, { FELINE } },	-- Winterspring Frostsaber
	[59791]={ { GROUND }, { MAMMOTH } },	-- Wooly Mammoth

-- horde mounts
	[61230]={ { GROUND }, { WINDRIDER } },	-- Armored Blue Wind Rider
	[60116]={ { GROUND }, { BEAR } },	-- Armored Brown Bear
	[35022]={ { GROUND }, { HAWKSTRIDER } },	-- Black Hawkstrider
	[64977]={ { GROUND }, { HORSE } },	-- Black Skeletal Horse
	[60119]={ { GROUND }, { BEAR, PVP } },	-- Black War Bear
	[22718]={ { GROUND }, { KODO, PVP } },	-- Black War Kodo
	[59788]={ { GROUND }, { MAMMOTH, PVP } },	-- Black War Mammoth
	[22721]={ { GROUND }, { RAPTOR, PVP } },	-- Black War Raptor
	[22724]={ { GROUND }, { WOLF, PVP } },	-- Black War Wolf
	[64658]={ { GROUND }, { WOLF } },	-- Black Wolf
	[35020]={ { GROUND }, { HAWKSTRIDER } },	-- Blue Hawkstrider
	[17463]={ { GROUND }, { HORSE } },	-- Blue Skeletal Horse
	[32244]={ { FLYING }, { WINDRIDER } },	-- Blue Wind Rider
	[18990]={ { GROUND }, { KODO } },	-- Brown Kodo
	[17464]={ { GROUND }, { HORSE } },	-- Brown Skeletal Horse
	[6654]={ { GROUND }, { WOLF } },	-- Brown Wolf
	[63635]={ { GROUND }, { RAPTOR } },	-- Darkspear Raptor
	[6653]={ { GROUND }, { WOLF } },	-- Dire Wolf
	[8395]={ { GROUND }, { RAPTOR } },	-- Emerald Raptor
	[63643]={ { GROUND }, { HORSE } },	-- Forsaken Warhorse
	[23509]={ { GROUND }, { WOLF, PVP } },	-- Frostwolf Howler
	[87090]={ { GROUND }, { MECHANICAL } }, -- Goblin Trike
	[87091]={ { GROUND }, { MECHANICAL } }, -- Goblin Turbo-Trike
	[61467]={ { GROUND }, { MAMMOTH, PVP } },	-- Grand Black War Mammoth
	[61469]={ { GROUND }, { MAMMOTH } },	-- Grand Ice Mammoth
	[18989]={ { GROUND }, { KODO } },	-- Gray Kodo
	[23249]={ { GROUND }, { KODO } },	-- Great Brown Kodo
	[65641]={ { GROUND }, { KODO } },	-- Great Golden Kodo
	[23248]={ { GROUND }, { KODO } },	-- Great Gray Kodo
	[23247]={ { GROUND }, { KODO } },	-- Great White Kodo
	[17465]={ { GROUND }, { HORSE } },	-- Green Skeletal Warhorse
	[32245]={ { GROUND }, { WINDRIDER } },	-- Green Wind Rider
	[59797]={ { GROUND }, { MAMMOTH } },	-- Ice Mammoth
	[93644]={ { GROUND }, { INSECT } },	-- Kor'kron Annihilator
	[55531]={ { GROUND }, { MECHANICAL, CRAFTED } },	-- Mechano-Hog
	[66846]={ { GROUND }, { HORSE } },	-- Ochre Skeletal Warhorse
	[63640]={ { GROUND }, { WOLF } },	-- Orgrimmar Wolf
	[35018]={ { GROUND }, { HAWKSTRIDER } },	-- Purple Hawkstrider
	[23246]={ { GROUND }, { HORSE } },	-- Purple Skeletal Warhorse
	[61997]={ { FLYING }, { SPECIAL } },	-- Red Dragonhawk
	[34795]={ { FLYING }, { HAWKSTRIDER } },	-- Red Hawkstrider
	[17462]={ { GROUND }, { HORSE } },	-- Red Skeletal Horse
	[22722]={ { GROUND }, { HORSE, PVP } },	-- Red Skeletal Warhorse
	[63642]={ { GROUND }, { HAWKSTRIDER } },	-- Silvermoon Hawkstrider
	[92232]={ { GROUND }, { PVP, HORSE } },	-- Spectral Wolf
	[66088]={ { FLYING }, { SPECIAL } },	-- Sunreaver Dragonhawk
	[66091]={ { GROUND }, { HAWKSTRIDER } },	-- Sunreaver Hawkstrider
	[23241]={ { GROUND }, { RAPTOR } },	-- Swift Blue Raptor
	[23250]={ { GROUND }, { WOLF } },	-- Swift Brown Wolf
	[65646]={ { GROUND }, { WOLF } },	-- Swift Burgundy Wolf
	[23252]={ { GROUND }, { WOLF } },	-- Swift Gray Wolf
	[35025]={ { GROUND }, { HAWKSTRIDER } },	-- Swift Green Hawkstrider
	[32295]={ { GROUND }, { WINDRIDER } },	-- Swift Green Wind Rider
	[68056]={ { GROUND }, { WOLF } },	-- Swift Horde Wolf
	[23242]={ { GROUND }, { RAPTOR } },	-- Swift Olive Raptor
	[23243]={ { GROUND }, { RAPTOR } },	-- Swift Orange Raptor
	[33660]={ { GROUND }, { HAWKSTRIDER } },	-- Swift Pink Hawkstrider
	[35027]={ { GROUND }, { HAWKSTRIDER } },	-- Swift Purple Hawkstrider
	[65644]={ { GROUND }, { RAPTOR } },	-- Swift Purple Raptor
	[32297]={ { GROUND }, { WINDRIDER } },	-- Swift Purple Wind Rider
	[65639]={ { GROUND }, { HAWKSTRIDER } },	-- Swift Red Hawkstrider
	[32246]={ { FLYING }, { WINDRIDER } },	-- Swift Red Wind Rider
	[23251]={ { GROUND }, { WOLF } },	-- Swift Timber Wolf
	[35028]={ { GROUND }, { HAWKSTRIDER, PVP } },	-- Swift Warstrider
	[32296]={ { GROUND }, { WINDRIDER } },	-- Swift Yellow Wind Rider
	[32243]={ { FLYING }, { WINDRIDER } },	-- Tawny Wind Rider
	[63641]={ { GROUND }, { KODO } },	-- Thunder Bluff Kodo
	[580]={ { GROUND }, { WOLF } },	-- Timber Wolf
	[61447]={ { GROUND }, { MAMMOTH } },	-- Traveler's Tundra Mammoth
	[10796]={ { GROUND }, { RAPTOR } },	-- Turquoise Raptor
	[64659]={ { GROUND }, { RAPTOR } },	-- Venomhide Ravasaur
	[10799]={ { GROUND }, { RAPTOR } },	-- Violet Raptor
	[64657]={ { GROUND }, { KODO } },	-- White Kodo
	[65645]={ { GROUND }, { HORSE } },	-- White Skeletal Warhorse
	[59793]={ { GROUND }, { MAMMOTH } },	-- Wooly Mammoth

-- paladin mounts
	[23214]={ { GROUND }, { HORSE } },	-- Alliance Charger
	[13819]={ { GROUND }, { HORSE } },	-- Alliance Warhorse
	[66906]={ { GROUND }, { HORSE } },	-- Argent Charger
	[73629]={ { GROUND }, { ELEKK } }, 	-- Exarch's Elekk
	[73630]={ { GROUND }, { ELEKK } },	-- Great Exarch's Elekk
	[69826]={ { GROUND }, { KODO } },	-- Great Sunwalker Kodo
	[34767]={ { GROUND }, { HORSE } },	-- Horde Charger
	[34769]={ { GROUND }, { HORSE } },	-- Horde Warhorse

-- warlock mounts
	[23161]={ { GROUND }, { HORSE } },	-- Dreadsteed
	[5784]={ { GROUND }, { HORSE } },	-- Felsteed

-- deathknight mounts
	[48778]={ { GROUND }, { HORSE } },	-- Acherus Deathcharger
	[54729]={ { FLYING }, { HORSE } },	-- Winged Steed of the Ebon Blade

-- egineering mounts
	[44153]={ { GROUND, FLYING }, { MECHANICAL, CRAFTED } },	-- Flying Machine
	[44151]={ { GROUND, FLYING }, { MECHANICAL, CRAFTED } },	-- Turbo-Charged Flying Machine

-- tailoring mounts
	[61451]={ { GROUND, FLYING }, { CRAFTED } },	-- Flying Carpet
	[75596]={ { GROUND, FLYING }, { CRAFTED } },	-- Frosty Flying Carpet
	[61309]={ { GROUND, FLYING }, { CRAFTED } },	-- Magnificent Flying Carpet
	[61444]={ { GROUND, FLYING }, { CRAFTED } },	-- Swift Shadoweave (Ebonweave) Carpet
	[61442]={ { GROUND, FLYING }, { CRAFTED } },	-- Swift Mooncloth Carpet
	[61446]={ { GROUND, FLYING }, { CRAFTED } },	-- Swift Spellfire Carpet

-- trading card game
	[51412]={ { GROUND }, { BEAR, TCG } },	-- Big Battle Bear
	[74856]={ { FLYING }, { TCG, HYPOGRYPH } }, -- Blazing Hippogryph
	[65917]={ { GROUND }, { TCG } },	-- Magic Rooster
	[30174]={ { GROUND }, { TCG } },	-- Riding Turtle
	[97581]={ { GROUND }, { RAPTOR, TCG } },	-- Savage Raptor
	[42776]={ { GROUND }, { FELINE, TCG } },	-- Spectral Tiger
	[42777]={ { GROUND }, { FELINE, TCG } },	-- Swift Spectral Tiger
	[46197]={ { FLYING }, { MECHANICAL, TCG } },	-- X-51 Nether-Rocket
	[46199]={ { FLYING }, { MECHANICAL, TCG } },	-- X-51 Nether-Rocket X-TREME 
};

-- New pally elekk
